
===============================================================
dgeom RELEASE NOTES: 05/04/25 RELEASE VERSION 2.48.1
===============================================================

Enhancements/ Additions:
------------------------

* Added geometry evaluation tolerance to DGEOM data structure.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 07/24/23 RELEASE VERSION 2.47.10
===============================================================

Enhancements/ Additions:
------------------------

* Added multi-zone capability for cases with multiple bodies
  and matching faces.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 04/20/23 RELEASE VERSION 2.46.29
===============================================================

Enhancements/ Additions:
------------------------

* Initial implementation of multi-zone capability.
  To be completed in the near future.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 04/13/23 RELEASE VERSION 2.46.25
===============================================================

Enhancements/ Additions:
------------------------

* Modified dgeom_data_free modes.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 11/20/22 RELEASE VERSION 2.46.24
===============================================================

Enhancements/ Additions:
------------------------

* Changed all sprintf calls to snprintf.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 10/18/22 RELEASE VERSION 2.46.23
===============================================================

Enhancements/ Additions:
------------------------

* Revised isolated interior edge refinement flag limits.

Bugs Fixed:
-----------

* Corrected quad formation flag maximum allowable value.

===============================================================
dgeom RELEASE NOTES: 05/20/22 RELEASE VERSION 2.46.21
===============================================================

Enhancements/ Additions:
------------------------

* Modified evaluation routines for evaluating uv at xyz to
  include a capability to use an estimate to improve accuracy
  and efficiency.

* Modified evaluation routines for evaluating xyz at t along an
  edge to include a discrete call-back function.

Bugs Fixed:
-----------

* Corrected discrete evaluation of edge tangent vector to use
  the extracted boundary-edge connectivity only.

===============================================================
dgeom RELEASE NOTES: 09/24/21 RELEASE VERSION 2.45.22
===============================================================

Enhancements/ Additions:
------------------------

* Added edge data to DGEOM data structure along with routines
  to set and get edge data.

* Added edge evaluation routines dgeom_cad_eval_edge_arclen,
  dgeom_cad_eval_xyz_at_t, dgeom_cad_eval_uv_at_t, and
  dgeom_eval_xyz_at_t from surf_auto routine egen_auto_eval_xyz_at_u.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 06/12/21 RELEASE VERSION 2.44.3
===============================================================

Enhancements/ Additions:
------------------------

* Modified dgeom_eval_uv_bounds to include true CAD uv-bounds.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 05/18/21 RELEASE VERSION 2.44.1
===============================================================

Enhancements/ Additions:
------------------------

* Added cut-off limit for quadratic scaling of UV for CAD geometry.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 04/11/21 RELEASE VERSION 2.43.2
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for EGADS effective surface definitions.

* Added routine to set and get the surface ID list for DGEOM
  discrete geometry definitions.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 02/08/21 RELEASE VERSION 2.42.3
===============================================================

Enhancements/ Additions:
------------------------

* Added edge scale factor data to surface definition data
  structure. Routines were added to allocate, set, and get the
  edge scale factor.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 09/21/20 RELEASE VERSION 2.41.2
===============================================================

Enhancements/ Additions:
------------------------

* Changes for inclusion of metric in DGEOM definition structure.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 09/04/20 RELEASE VERSION 2.40.3
===============================================================

Enhancements/ Additions:
------------------------

* Added geometry definition status flag to DGEOM data structure.

* Added automatic setting of the DGEOM data structure grid BC
  flag from the DGEOM definition structure values.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 08/18/20 RELEASE VERSION 2.39.7
===============================================================

Enhancements/ Additions:
------------------------

* Added isolated edge refinement flag mier4 to surface definition
  data structure.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 07/30/20 RELEASE VERSION 2.38.15
===============================================================

Enhancements/ Additions:
------------------------

* Changes to clarify and restructure how surface definition data
  is stored and retrieved.

* Revised substantially how surface definition data is stored
  and retrieved.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 04/28/20 RELEASE VERSION 2.36.1
===============================================================

Enhancements/ Additions:
------------------------

* Modified u,v mapping used for scaling and singularity removal
  in CAD geometry definitions and eliminated internal parameters
  and limits. The primary process however did not change.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 04/19/20 RELEASE VERSION 2.35.5
===============================================================

Enhancements/ Additions:
------------------------

* Changed u,v mapping modification to use reduced scaling with
  CAD definitions that have a bounding curve that includes a
  discontinuity (collapsed edge in x,y,z space).

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 03/04/20 RELEASE VERSION 2.35.4
===============================================================

Enhancements/ Additions:
------------------------

* Changed u,v mapping modification to not use scaling with
  CAD definitions that have a bounding curve that includes a
  discontinuity (collapsed edge in x,y,z space).

* Modifications for surface based background mesh length scale
  interpolation.

* Added surface reordering for glue only composites so that the
  normals are consistently ordered into the domain.

* Changes for compatibility.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 10/26/19 RELEASE VERSION 2.34.1
===============================================================

Enhancements/ Additions:
------------------------

* Added routines to save length scale "df" for each definition.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 07/29/19 RELEASE VERSION 2.33.9
===============================================================

Enhancements/ Additions:
------------------------

* Changes to allow CAD based curvature evaluation to have a lower
  and upper limit to uv values. This change is required for
  compatibility with LIB egads_aflr4.

* Changes to minimize redundant searching within the data base
  for a given surface definitions.

* Modified process to add and glue component surfaces within a 
  composite surface definition. These modifications improve
  efficiency of the process significantly without altering the
  result.

* Modified CAD surface definition mapping transformation.
  The modified form improves the resulting surface mesh for
  cases that with a singular or near singular end point.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 05/06/19 RELEASE VERSION 2.32.5
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for high-order evaluation of discrete geometry.

* Added curvature evaluation routine for discrete geometry.

* Changes for compatibility.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 02/05/19 RELEASE VERSION 2.31.3
===============================================================

Enhancements/ Additions:
------------------------

* Modified gluing in dgeom_glue_comp to add the capability for
  non-manifold connections.

* Added background surface definition grid to dgeom data structure.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 01/24/19 RELEASE VERSION 2.30.5
===============================================================

Enhancements/ Additions:
------------------------

* API change in surfgen_cad_eval_bedge for compatibility.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 09/25/18 RELEASE VERSION 2.30.1
===============================================================

Enhancements/ Additions:
------------------------

* CAD surfaces use a uv transformation when the uv space has a
  singularity and/or uv space is a thin rectangular region in
  in physical space. The former remapping is required to mesh
  singularities and the later uv space scaling helps efficiency.
  However, scaling can amplify distortion in uv space for cases
  with singularities and trim curves. In the new version, scaling
  is turned off if a singularity is detected.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 09/05/18 RELEASE VERSION 2.29.5
===============================================================

Enhancements/ Additions:
------------------------

* Added capability to register a routine to evaluate curvature
  and principle direction vectors on CAD surface definitions.

* Local u,v for individual surfaces definitions is now included
  in the data for glue only composite definitions.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 08/01/18 RELEASE VERSION 2.28.2
===============================================================

Enhancements/ Additions:
------------------------

* Removed function dgeom_eval_bedge_reset in dgeom_eval_bedge.c
  and added function dgeom_def_reset_bedge_x in dgeom_def.c

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 05/21/18 RELEASE VERSION 2.28.1
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected error in scaling of surface definition patches with
  singularities.

===============================================================
dgeom RELEASE NOTES: 08/01/18 RELEASE VERSION 2.28.2
===============================================================

Enhancements/ Additions:
------------------------

* Removed function dgeom_eval_bedge_reset in dgeom_eval_bedge.c
  and added function dgeom_def_reset_bedge_x in dgeom_def.c

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 05/21/18 RELEASE VERSION 2.28.1
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected error in scaling of surface definition patches with
  singularities.

===============================================================
dgeom RELEASE NOTES: 03/05/18 RELEASE VERSION 2.28.0
===============================================================

Enhancements/ Additions:
------------------------

* Modifications to accommodate auto-edge and surface mesh
  generation in AFLR4.

Bugs Fixed:
-----------

===============================================================
dgeom RELEASE NOTES: 11/28/17 RELEASE VERSION 2.27.3
===============================================================

Enhancements/ Additions:
------------------------

* Modifications to accommodate change in boundary-edge grid
  treatment in AFLR4.

* Added routine dgeom_regen_bedge to dgeom_eval_bedge routines
  for regeneration of boundary edge grids using a background
  mesh or similar process. An external routine may be registered
  for this capability.

Bugs Fixed:
-----------


===============================================================
dgeom RELEASE NOTES: 08/07/17 RELEASE VERSION 2.24.43
===============================================================

Enhancements/ Additions:
------------------------

* Added external/extra CAD geometry data to the geometry definition
  data structure for passing to external CAD evaluation routines.
  Note that the APIs for external functions that are defined in the
  dgeom_register_cad_* routines were modified to accommodate this
  change.

Bugs Fixed:
-----------


===============================================================
dgeom RELEASE NOTES: 05/11/17 RELEASE VERSION 2.23.41
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with 64-bit integers.

Bugs Fixed:
-----------

* Reduced default search tolerance used for locating points on edges
  and in faces of surfaces. This eliminates erroneous projections
  along edges very close to corners.

===============================================================
dgeom RELEASE NOTES: 02/13/17 RELEASE VERSION 2.22.41
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with 64-bit integers.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 12/16/16 RELEASE VERSION 2.21.40
===============================================================

Enhancements/ Additions:
------------------------

* Added new check in dgeom_cad_setup_uvmod for scaling of surface
  definition patches.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 05/14/16 RELEASE VERSION 2.20.35
===============================================================

Enhancements/ Additions:
------------------------

* Updated data structure and routines for use of modified
  least-squares optimized boundary surface normal routines.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 03/19/16 RELEASE VERSION 2.18.31
===============================================================

Enhancements/ Additions:
------------------------

* Minor syntax change in if check.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 12/02/15 RELEASE VERSION 2.18.29
===============================================================

Enhancements/ Additions:
------------------------

* Added normal spacing to definition data structure for use
  with AFLR3.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 01/20/15 RELEASE VERSION 2.17.27
===============================================================

Enhancements/ Additions:
------------------------

* Added capability to register CAD routine to specify the
  uv-mapping bounds for each CAD geometry surface definition.

* Added capability to register CAD and/or discrete geometry
  routines for setting the boundary edge grid.

* Removed direct storage of quad faces and added a quad map
  to recover at a later time.

* Added additional data stored for each geometry definition
  for grid generation needs.

* Modified internal and external APIs to accommodate changes.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 01/20/15 RELEASE VERSION 2.17.27
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected possible gluing error with composite surfaces when
  the relative tolerance is set (mgtol=1).

===============================================================
dgeom RELEASE NOTES: 08/14/14 RELEASE VERSION 2.17.26
===============================================================

Enhancements/ Additions:
------------------------

* Added routine dgeom_def_alloc_bgen to allocate boundary edge
  grid data in file dgeom_def.c.

* Modified internal API for surface search (ug3_srchbf) to allow
  for a two-pass algorithm that uses a large tolerance on the
  second pass to find locations that are off the surface and near
  a surface node.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 05/13/14 RELEASE VERSION 2.16.25
===============================================================

Enhancements/ Additions:
------------------------


Bugs Fixed:
-----------

* Corrected an error in evaluating xyz coordinates at given
  estimated xyz coordinates. The error could occur if the
  surface was defined as a discrete surface and the given
  coordinates exactly matched a those of at a point on the 
  discrete definition.

===============================================================
dgeom RELEASE NOTES: 02/23/14 RELEASE VERSION 2.14.23
===============================================================

Enhancements/ Additions:
------------------------

* Added option to not output an error message to the following
  routines.

     dgeom_eval_bv_at_xyz
     dgeom_eval_bv_at_xyz_in
     dgeom_eval_ibf_at_xyz
     dgeom_eval_tv_at_xyz_edge
     dgeom_eval_xyz_at_xyz

===============================================================
dgeom RELEASE NOTES: 02/11/14 RELEASE VERSION 2.13.23
===============================================================

Enhancements/ Additions:
------------------------

* Convert to new ug parameter structure scheme and eliminate
  use of Error_Message.

* Eliminate output of an error message when a composite surface
  isn't found before it is defined.

Bugs Fixed:
-----------


===============================================================
dgeom RELEASE NOTES: 10/16/13 RELEASE VERSION 2.12.19
===============================================================

Enhancements/ Additions:
------------------------

* Added capability to determine the edge vector on a discrete
  surface at a given xyz location.

* Added capability to project an xyz location onto a discrete
  surface and its edge curve at a given xyz location.

Bugs Fixed:
-----------


===============================================================
dgeom RELEASE NOTES: 09/11/13 RELEASE VERSION 2.11.18
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Correct uninitialized variable use (the result was not actually
  used).


===============================================================
dgeom RELEASE NOTES: 08/01/13 RELEASE VERSION 2.10.18
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Removed uninitialized variable use (the result was not actually
  used).


===============================================================
dgeom RELEASE NOTES: 03/16/13 RELEASE VERSION 2.10.15
===============================================================

Enhancements/ Additions:
------------------------

* Updated character string declarations.

Bugs Fixed:
-----------

* 

===============================================================
dgeom RELEASE NOTES: 01/30/13 RELEASE VERSION 2.10.14
===============================================================

Enhancements/ Additions:
------------------------

* Added a quality check for mappings based on projecting to a plane.

* Modified parameters in data structure for mappings based on
  projecting to a plane.

Bugs Fixed:
-----------

* Corrected an error in evaluating uv at xyz for a set of nodes
  if the surface definition is a CAD definition.
